%%% A simple classical code for expert system
%%% Direct use of Prolog 

:- dynamic xpositive/2.
:- dynamic xnegative/2.


run:-
    write('An Expert Systems for Animals'), nl, nl,
    write('Answer the following questions with yes/no'), nl,nl,
    animal_is(X),
    write('The animal may be: '), write(X), nl, nl.
  %  clear_facts.

    positive(X,Y):- xpositive(X,Y),!.
    positive(X,Y):- not(negative(X,Y)), !, ask(X,Y).
    negative(X,Y):- xnegative(X,Y), !.


    ask(X,Y):-
        write(X), write(' it '), write(Y), nl,
        read(Reply),
        remember(X,Y,Reply).
    remember(X,Y,yes):-
        asserta(xpositive(X,Y)).
    remember(X,Y,no):-
        asserta(xnegative(X,Y)),
        fail.


    clear_facts:-
        retract(xpositive(_,_)),fail.
    clear_facts:-
        retract(xnegative(_,_)),fail.
   % clear_facts:- nl,nl,  write('Please press the dot to Exit'), read(_).

    animal_is(cheetah):-
        it_is(mammal),
        it_is(carnivore),
        positive(has,tawny_color),
        positive(has,black_spots),!.
    animal_is(tiger):- 
        it_is(mammal),
        it_is(carnivore),
        positive(has,tawny_color),
        positive(has,black_stripes),!.
    animal_is(giraffe):- 
        it_is(ungulate),
        positive(has,long_neck),
        positive(has,long_legs),
        positive(has,dark_spots),!.
    animal_is(zebra):-
        it_is(ungulate),
        positive(has,black_stripes),!.
    animal_is(ostrich):- 
        it_is(bird),
        not(positive(does,fly)),
        positive(has,long_neck),
        positive(has,long_legs),!.
    animal_is(penguin):- 
        it_is(bird),
        not(positive(does,fly)),
        positive(does,swim),
        positive(has,black_and_white_color),!.
    animal_is(albatross):-
        it_is(bird),
        positive(does,fly),
        positive(does,fly_well),!.

    it_is(mammal):-
        positive(has,hair),
        positive(does,give_milk),!.
    it_is(carnivore):-
        it_is(mammal),
        positive(does,eat_meat),
        positive(has,pointed_teeth),
        positive(has,claws),!.
    it_is(ungulate):-
        it_is(mammal),
        positive(has,hooves),
        positive(does,chew_cud),!.
    it_is(bird):-
        not(positive(has,hair)),
        not(positive(does,give_milk)),
        positive(has,feathers),
        positive(does,lay_eggs),!.
