%wyznaczanie kluczy relacji ver2
%autor - Bartomiej Ciesielczyk
%algorytm sowny
%1-Wyznaczenie zbioru (A) atrybutw, ktrych nie da si wyznaczy z zalenoci funkcyjnych.
%2-Wyznaczenie zbioru B=L_wszyst_atr-A.
%3-Tworzenie kombinacji (Komb) K elementowych zbioru B (K=0 do length(B)).
%4-Tworzenie zbioru Z=A+Komb.
%5-Sprawdzenie czy Z nie jest nadkluczem. Jeli tak powrt do 3.
%6-Stworzenie zbioru atrybutw do wyznaczenia W=L_wszyst_atr-Z.
%7-Prba wyznaczenia wszystkich atrybutw z W przy pomocy atrybutw z zbioru Z i danych zalenociach funkcyjnych.
%8-W przypadku powodzenia dodanie nowego klucza do bazy.
%9-Powrt do 3. 

%zalenoci funkcyjne: wyznacza(Lista_atrybutw,Atrybut);
%wywoanie: klucze(Lista_atrybutw_relacji<podana>,Klucz<zmienna nieukonkretniona>);   
 
%---lista_liczb(Min,Max,Lista)- lista liczb od Min do Max
lista_liczb(M,M,[M]):- !.
lista_liczb(Min,Max,[Min|L]) :-
		Min1 is Min+1,
		lista_liczb(Min1,Max,L).

%---nalezydo(A,B) - czy zbir A zawiera si w zbiorze B
nalezydo([],_).
nalezydo([G1|O1],B):-
	member(G1,B),
	nalezydo(O1,B).

%---kombinacja(L,K,C) C, K-elementowa z listy L
kombinacja(_,0,[]):- !.
kombinacja(L,K,[H|T]) :-
	K1 is K-1,
	append(_,[H|U],L),
	append([],U,W),
	kombinacja(W,K1,T).

%---difference(A,B,C) - rnica C list A i B C=A-B      
difference([],_,[]).
difference([X|L],Set,[X|Z]):-
      not(member(X,Set)),!,
      difference(L,Set,Z).
difference([_|L],Set,Z):-
      difference(L,Set,Z).

%---Czyszczenie pamieci
clear_klucz:- retract(klucz(_)),fail.
clear_klucz.
%-------------------------------------------------------------------------------------
%---to_mozna_wyzn(M), M - lista atrybutw ktre mona wyznaczy z zalenoci funkcyjnych
to_mozna_wyzn(M):- 
	clear_mozna_wyzn,
	assert(mozna_wyzn([])),
	co_mozna_wyzn,
	mozna_wyzn(M).

%---co_mozna_wyzn - generacja listy atrybutw, ktre mona wyznaczy z zalenoci funkcyjnych
co_mozna_wyzn:-
	wyznacza(_,Atr),
	mozna_wyzn(M),
	not(member(Atr,M)),
	retract(mozna_wyzn(_)),
	assert(mozna_wyzn([Atr|M])),
	fail.
co_mozna_wyzn.

%---Czyszczenie pamieci
clear_mozna_wyzn:- retract(mozna_wyzn(_)),fail.
clear_mozna_wyzn.
%----------------------------------------------------------------------------------------
%---wyznacz_all(A,B) - prba wyznaczenia wszystkich elementw zbioru A, przy pomocy elementw zbioru B z wykorzystaniem zalenoci funkcyjnych  
wyznacz_all([],_):- !.
wyznacz_all(Dowyzn,Znane) :-
	append(L1,[Atr_do_wyzn|L2],Dowyzn),
	wyznacza(To_wyznacza,Atr_do_wyzn),
	nalezydo(To_wyznacza,Znane), %udao sie wyznaczy kolejny atrybut
	!,
	append(L1,L2,Dowyzn1), %usunicie wyznaczonego atrybutu z Dowyzn
	wyznacz_all(Dowyzn1,[Atr_do_wyzn|Znane]). %dodanie atrybutu do Znane

%---nadklucz(K) - sprawdza czy K jest nadkluczem
nadklucz(K) :-
	klucz(M),
	nalezydo(M,K).
	
%---klucze(Lista_atr,Klucz) - wyznacza Klucze relacji o podanej licie atrybutw i zapisanych w bazie zalenociach funkcyjnych
klucze(Lista_atr,Klucz):-
	clear_klucz,
	to_mozna_wyzn(Mozna_wyzn),
	difference(Lista_atr,Mozna_wyzn,Czesc_klucza),
	length(Mozna_wyzn,Liczba_atr1),
	lista_liczb(0,Liczba_atr1,L_liczb),
	append(_,[Liczba|_],L_liczb),
	kombinacja(Mozna_wyzn,Liczba,Komb),
	append(Czesc_klucza,Komb,Klucz),
	not(nadklucz(Klucz)),
	difference(Lista_atr,Klucz,Dowyzn),
	wyznacz_all(Dowyzn,Klucz),
	assert(klucz(Klucz)).
		
%----------------------------------------------------------------------------
%zaleznosci funkcyjne
%1
%wyznacza([a],b).
%wyznacza([b],c).
%wyznacza([c],d).
%wyznacza([d],a).
wyznacza([miasto,ulica],kod).
wyznacza([kod],miasto).

% Ex1
%wyznacza([m,n],k).
%wyznacza([k],l).
%wyznacza([l],m).

%wyznacza([l,m],k).
%wyznacza([m,n],l).
%wyznacza([n,l],m).

%2
/*
wyznacza([sklep,towar],dzial).
wyznacza([sklep,dzial],kierownik).
*/
%3
%wyznacza([miasto,dzielnica],symbol_rejestracyjny_samochodu).
%wyznacza([miasto,symbol_rejestracyjny_samochodu],dzielnica).
%wyznacza([symbol_rejestracyjny_samochodu],miasto).

%4 - 6 atrybutow
/*
wyznacza([lot],lotnisko_przeznaczenia).
wyznacza([lot],godzina).
wyznacza([dzien,lot],wyjscie_dla_pasazerow).
wyznacza([dzien,lot],pilot).
wyznacza([dzien,godzina,pilot],wyjscie_dla_pasazerow).
wyznacza([dzien,godzina,pilot],lot).
wyznacza([dzien,godzina,pilot],lotnisko_przeznaczenia).
wyznacza([dzien,godzina,wyjscie_dla_pasazerow],pilot).
wyznacza([dzien,godzina,wyjscie_dla_pasazerow],lot).
wyznacza([dzien,godzina,wyjscie_dla_pasazerow],lotnisko_przeznaczenia).
*/
%5 - 9 atrybutow
/*
wyznacza([numer_medyczny,data_przyjecia,czas],diagnoza).
wyznacza([numer_medyczny,data_przyjecia,czas],nazwisko_lekarza).
wyznacza([numer_medyczny],nazwisko_pacjenta).
wyznacza([nazwisko_lekarza],adres_lekarza).
wyznacza([miejsce_pracy],adres_miejsca_pracy).
wyznacza([numer_medyczny],miejsce_pracy).
*/
pytanie4(Klucz) :- 
	klucze([lot,lotnisko_przeznaczenia,godzina,dzien,wyjscie_dla_pasazerow,pilot],Klucz).

pytanie5(Klucz) :-
	klucze([numer_medyczny,data_przyjecia,czas,diagnoza,nazwisko_lekarza,nazwisko_pacjenta,miejsce_pracy,adres_miejsca_pracy],Klucz).


