/* PLAN - program znajdowania trasy polaczen miedzy miastami */
:- dynamic(d/6).
:- dynamic(coorde/3).
:- consult('krakow-graph.pl').
%%% Przeszukiwanie wgłąb z nawrotami
:- dynamic(p/1).
:- dynamic(p/6).
:- dynamic(q/2).
%%% p(<state>,<decision>,<goal>,<robustnes_factor>,<min_cost>,<max_cost>). %%%
%%% p(<current_node>,<next_node>,<goal_node>,<number_of_plans>,<min_cost>,<max_cost>).%%%
d(s,v1,5).
d(s,v2,7).
d(v1,v3,5).
d(v1,v4,4).
d(v2,v4,3).
d(v2,v5,6).
d(v3,v6,4).
d(v4,v6,3).
d(v4,v7,2).
d(v5,v7,7).
d(v6,g,2).
d(v7,g,5).

nodes([s,n1,n2,n3,n4,n5,n6]).

%%% domknięcie symetryczne relacji d/2 
     link(X,Y,D):- d(X,Y,D).
     link(X,Y,D):- d(Y,X,D).
          
%%% główna pętla szukania trasy
%%% szukaj_trasy(Start,Cel,Robocza,Trasa,DlugoscRoboczej,DlugoscTrasy,Ograniczenie).

szukaj_trasy(Miasto,Miasto,Trasa,Trasa,Dystans,Dystans,_):- !.
szukaj_trasy(Miasto,Cel,Robocza,Trasa,Dlugosc,Dystans,Ograniczenie):-
     link(Miasto,Kandydat,D),
     not(member(Kandydat,Robocza)),
     NowaDlugosc is Dlugosc + D,
     NowaDlugosc < Ograniczenie,
     szukaj_trasy(Kandydat,Cel,[Kandydat|Robocza],Trasa,
                  NowaDlugosc,Dystans,Ograniczenie).

%%% Inicjacja poszukiwan

plan(Miasto,Next,Cel,Trasa,Dystans,Ograniczenie):-
     szukaj_trasy(Next,Cel,[Next,Miasto],Trasa,0,Dystans,Ograniczenie). %%% !.
                                                  
%%% Find all plans from 's' to 'g'.
     fap(Plans) :- findall(Trasa, plan(s,g,Trasa,_,100),Plans).
%%% Find all plans, lengths, count, min, max: from X through Y to G. R - restriction of max distance

     fa(X,Next,G,Plans,R):- findall(s(Plan,Dist),plan(X,Next,G,Plan,Dist,R),Plans).

%%%%% To do:
%%%%% Simple: for any n \in N find all decions/nexts, routes to goal, and assert decision, no_of_plans, min and max.
%%%%% Advanced: recurion on nodes. for a node find all routes to goal (nowe drogi), but if
%%%%% a route hits a visited node, just recall all the calculated roads (excluding backtrack).
%%%%% Jedno-dukierunkowosc
%%%%% Czyszcenie bazy
%%%%% Import z mapy

%%%%% A* lub inne (Nowak) do liczenia tras(y) odniesienia.

%%% Find all plans and assert; p(<plan>).
     fap-assert:- plan(s,g,Plan), assert(p(Plan)), fail.
     fap-assert.

%%% Count: zliczanie krotnosci wezla w planach.
     count(N,_):- p(P), member(N,P), add(N), fail.
     count(N,K):- q(N,K).

add(N):- \+ q(N,_),!, assert(q(N,1)).
add(N):- retract(q(N,K)), K1 is K+1, assert(q(N,K1)).

     countall:- nodes(LN), select(N,LN,_), count(N,K), write('node: '), write(N), write('  in: '), write(K),nl.

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%% Utilities

writelist([]):- write('*****end*****'),nl,!.
writelist([H|T]):- write(H), nl, writelist(T).
