/* PLAN - program znajdowania trasy polaczen miedzy miastami */
%%% Przeszukiwanie wgłąb z nawrotami

%%% d(w1,w2,c) - link z w1 do w2 z kosztem c.

io(g1,[e1,e2,e3,e4,e5,e6]).
in(g1,[n1,n2,n3,n4,n5,n6,n7]).
d(e1,n1,3).
d(e1,n2,2).
d(e2,n2,3).
d(e6,n1,2).
d(n2,n7,3).
d(n7,e3,2).
d(n2,n4,3).
d(n4,n5,4).
d(n4,n6,3).
d(n6,e4,4).
d(n5,e4,3).
d(n3,n5,2).
d(n3,e5,4).
d(n1,n3,3).
d(e5,e6,7).

/* Wypisywanie listy miast */
writelist([]).
writelist([X|XT]):- write(X),nl,writelist(XT).

%%% domkniecie symetryczne droga/2

przejazd(X,Y,D):- d(X,Y,D).
przejazd(X,Y,D):- d(Y,X,D).


%%% główna pętla szukania trasy

%%% szukaj_trasy(Start,Cel,Robocza,Trasa,DlugoscRoboczej,DlugoscTrasy,Ograniczenie).

szukaj_trasy(Cel,Cel,Trasa,Trasa,Dystans,Dystans,_).   %%% !.
szukaj_trasy(Miasto,Cel,Robocza,Trasa,Dlugosc,Dystans,Ograniczenie):-
     przejazd(Miasto,Kandydat,D),
     not(member(Kandydat,Robocza)),
     NowaDlugosc is Dlugosc + D,
     NowaDlugosc < Ograniczenie,
     szukaj_trasy(Kandydat,Cel,[Kandydat|Robocza],Trasa,
                  NowaDlugosc,Dystans,Ograniczenie).

%%% Inicjacja poszukiwan

plan(Miasto,Cel,Trasa,Dystans,Ograniczenie):-
     szukaj_trasy(Cel,Miasto,[Cel],Trasa,0,Dystans,Ograniczenie). %%% !.

%%% fart - find all routes to
fart(G,N,T,C):- 
	io(_,LIO), in(_,LIN), append(LIO,LIN,LN), delete(LN,G,LNG),
        select(N,LNG,_),
        plan(N,G,T,C,100).

goto(G):-
	findall(t(I,T,C),fart(G,I,T,C),S),
        writelist(S).
                                           
